
ML:     equ  733
LOCATE: equ  65536-ML-9-(22*32)-768
        org  LOCATE

FETCHS: equ  $2bf1           ;from calculator stack: AEDCB
STAKA:  equ  $2d28           ;to calculator stack: A
STAKBC: equ  $2d2b           ;to calculator stack: BC
FPTOBC: equ  $2da2           ;from calculator stack: BC
FPTOA:  equ  $2dd5           ;from calculator stack: A
CH_ADD: equ  23645

;stack function parameters passed from BASIC by:
;PRINT USR mcst,arg1[,arg2...,argn],addr;
STACK:  ld   hl,14
        add  hl,sp
        ld   sp,hl           ;undo USR
GETARG: rst  $20
        call $24fb           ;SCANNING
        rst  $18
        cp   ","
        jr   z,GETARG
        call FPTOBC          ;BC=addr
        ld   h,b
        ld   l,c
        jp   (hl)            ;JP addr


;      ------------------------------------------------------------
;      *****
;      PRINT USR mcst,"s$()",m(k1,k1),m(k1,k2),m(k2,k1),m(k2,k2),d(scr,k1),d(scr,k2),ws,mcmv;
R1:     defw 0000   ;(ix+00) ;selected area top-LH corner
C1:     defw 0000   ;(ix+02) ;              "
R2:     defw 0000   ;(ix+04) ;selected area bottom-RH corner
C2:     defw 0000   ;(ix+06) ;              "
DATAAD: defw 0000   ;(ix+08) ;encoded screen data start in DATA line
DATALE: defw 0000   ;(ix+10) ;encoded screen data length
WORKSP: defw 0000   ;(ix+12) ;data start for encoding workspace (22*32+768)

CHARSP: defw 0000   ;(ix+14) ;data start for s$() screen buffer (22*32)
FBPAIN: defb 00     ;(ix+16) ;current FLASH,BRIGHT,PAPER,INK
TAB:    defb 00     ;(ix+17) ;current TAB position
COL:    defb 00     ;(ix+18) ;current column
TOKEN:  defb 00     ;(ix+19) ;print control token code

DISPLAY:equ  16384
ATTRIBS:equ  22528

; characters " " to UDG "U" are coded as normal;
; print controls AT to TAB (172 to 173) and INK to OVER (217 to 222) use their tokens;
; numeric parameters following print controls use characters "" to "" for numbers 0 to 31 (thus "a" to "z" = 1 to 26);

MCMOVE: ld   b,7             ;B =#numeric parameters
        ld   ix,WORKSP
NXTPAR: push bc           ;1>
        call FPTOBC
        ld   (ix+0),c
        ld   (ix+1),b
        dec  ix
        dec  ix
        pop  bc           ;1<
        djnz NXTPAR
        ld   ix,R1

        call FIND_S          ;(CHARSP) = s$() array data address
        ld   a,%00111000     ;PAPER white, INK black
        ld   (FBPAIN),a
        ld   de,(WORKSP)

        ;calculate starting offset for current row (=row*32 + col)
NEXTROW:push de           ;1>;position in workspace
        ld   a,(R1)
        call STAKA
        ld   a,32
        call STAKA
        rst  $28
        defb $04,$38
        call FPTOBC
        ld   hl,(C1)
        add  hl,bc           ;HL=R1*32 + C1
        ld   d,h
        ld   e,l
        ld   bc,(CHARSP)
        add  hl,bc           ;HL=start of row segment in s$()
        ex   de,hl           ;HL=R1*32 + C1; DE=position in s$()
        ld   bc,ATTRIBS
        add  hl,bc           ;HL=start of row segment in attributes
        pop  bc            ;1<
        push de            ;1>
        ld   d,b
        ld   e,c             ;DE=position in workspace

        ld   a,(COL)         ;check if AT R1,C1 is needed
        cp   32
        jr   nz,DOAT
        ld   a,(C1)
        or   a
        jr   z,NOAT

DOAT:   ld   (ix+19),172     ;AT
        ld   a,(C1)
        ld   b,a
        ld   a,(R1)
        call PRCONT          ;specify start position for this row
NOAT:   ld   a,(C1)
        ld   (TAB),a
        ld   (COL),a
        pop  bc           ;1<

NEXTCOL:push bc           ;1>;BC=position in s$()
        ld   a,(FBPAIN)      ;A =old FLASH,BRIGHT,PAPER,INK
        cp   (hl)            ;compare to new character's attributes
        jr   z,CHKCHR
        ;TAB to current position if not already there,
        ;then specify the attribute changes
        call CHKTAB
        ld   c,%10000000     ;mask for FLASH
        ld   (ix+19),219     ;FLASH
        call CPATTR
        ld   c,%01000000     ;mask for BRIGHT
        ld   (ix+19),220     ;BRIGHT
        call CPATTR
        ld   c,%00111000     ;mask for PAPER
        ld   (ix+19),218     ;PAPER
        call CPATTR
        ld   c,%00000111     ;mask for INK
        ld   (ix+19),217     ;INK
        call CPATTR
        ld   a,(hl)          ;A =new FLASH,BRIGHT,PAPER,INK
        ld   (FBPAIN),a

CHKCHR: pop  bc           ;1<;BC=position in s$()
        ld   a,(bc)
        cp   " "
        jr   z,NXTCHR
        push bc           ;1>
        push af           ;2>
        call CHKTAB
        pop  af           ;2<
        ex   de,hl           ;HL=position in workspace
        ld   (hl),a
        inc  hl
        ex   de,hl           ;HL=position in attributes
        inc  (ix+17)         ;TAB
        pop  bc           ;1<
NXTCHR: inc  bc              ;BC=position in s$()
        inc  hl
        inc  (ix+18)         ;COL
        ld   a,(ix+06)       ;COL2
        cp   (ix+18)
        jp   nc,NEXTCOL
        call CHKTAB
        inc  (ix+00)         ;R1
        ld   a,(ix+04)       ;R2
        cp   (ix+00)
        jp   nc,NEXTROW

        ;finished encoding screen segment
        ;reclaim old DATA string and replace with data from WORKSP
        push de           ;1>
        ld   hl,(DATAAD)     ;encoded screen data start in DATA line
        ld   bc,(DATALE)     ;encoded screen data length
        ld   a,b
        or   c
        jr   z,INSDATA
        call $19e8           ;RECLAIM_2
INSDATA:ex   de,hl           ;DE=encoded screen data start in DATA line
        pop  hl           ;1<;HL=current position in workspace
        ld   bc,(WORKSP)     ;BC=data start for encoding workspace
        and  a
        sbc  hl,bc
        jp   c,$1f15         ;"4 - Out of memory"
        add  hl,bc
        push bc           ;1>
        and  a
        sbc  hl,bc
        ld   b,h
        ld   c,l             ;BC=encoded length
        push bc           ;2>
        ex   de,hl           ;HL=encoded screen data start in DATA line
        call $1655           ;MAKE_ROOM
        inc  hl              ;HL=encoded screen data start in DATA line
        pop  bc           ;2<;BC=encoded length
        pop  de           ;1<
        ex   de,hl           ;HL=workspace start; DE=DATA string start
        push bc           ;1>
        ldir                 ;copy encoded screen data to DATA line
        ld   hl,(DATAAD)     ;encoded screen data start in DATA line
        ld   de,8
        and  a
        sbc  hl,de           ;HL=line length address
        pop  bc           ;1<;BC=encoded length
        ex   de,hl
        add  hl,bc           ;HL=new line length (DATA+8)
        ex   de,hl
        ld   (hl),e
        inc  hl
        ld   (hl),d
        inc  hl
        inc  hl
        inc  hl
        ld   (hl),"n"
        ret

FIND_S: call FETCHS          ;DE=array name address
        ld   a,b
        or   c
        jp   z,$288b         ;"Q - Parameter error"
        ld   bc,(CH_ADD)
        push bc           ;1>
        ld   (CH_ADD),de
        call $28b2           ;LOOK_VARS
        jp   c,$1c2e         ;"2 - Variable not found"
        pop  bc           ;1<;HL=s$() array header address
        ld   (CH_ADD),bc
        ld   bc,6
        add  hl,bc           ;HL=s$() array data address
        ld   (CHARSP),hl
        ret

CHKTAB: ld   a,(COL)
        cp   (ix+17)         ;cp COL to TAB
        ret  z
        ld   (ix+19),173     ;TAB
        ld   (TAB),a
        ld   b,0
        cp   32
        jr   nz,PRCONT
        dec  a               ;ensure TAB 32 wraps to next line
        call PRCONT          ;by doing TAB 31
        xor  a               ;then
        jr   PRCONT          ;TAB 00

CPATTR: ld   a,(FBPAIN)      ;A =old FLASH,BRIGHT,PAPER,INK
        and  c               ;mask those not being checked
        ld   b,a             ;B =old attribute
        ld   a,(hl)          ;A =new attributes
        and  c               ;A =new attribute
        cp   b
        ret  z               ;no difference
        ld   b,$ff           ;no 2nd parameter
SHIFT:  srl  c
        jr   c,PRCONT
        srl  a               ;shift new value to RH-side of A
        jr   SHIFT

PRCONT: ex   de,hl           ;HL=position in workspace
        ld   c,(ix+19)       ;C =print control token code
        ld   (hl),c
        inc  hl
        add  a,96
        ld   (hl),a          ;1st parameter
        inc  hl
        ld   a,b
        cp   $ff
        jr   z,NO2ND         ;no 2nd parameter
        add  a,96
        ld   (hl),a          ;2nd parameter
        inc  hl
NO2ND:  ex   de,hl           ;HL=position in attributes
        ret


;      ------------------------------------------------------------
;      *****
;      PRINT USR mcst,d(scr,k1),d(scr,k2),mcer;
ERASE:  call FPTOBC          ;BC=DATA length
        push bc
        call FPTOBC          ;BC=DATA start
        ld   h,b
        ld   l,c             ;HL=DATA start
        ld   de,4
        and  a
        sbc  hl,de
        ld   (hl),"n"        ;set decoded flag
        add  hl,de
        ld   d,h
        ld   e,l             ;DE=DATA start
        pop  bc              ;BC=DATA length
        add  hl,bc           ;HL=DATA closing " address
        push bc
        push de
        call $19e5           ;RECLAIM_1
        pop  hl              ;HL=old DATA start & new closing " address
        pop  bc              ;BC=old DATA length
        ld   de,7
        sbc  hl,de           ;HL=line length hi-byte address
        ld   d,(hl)
        dec  hl
        ld   e,(hl)          ;DE=old line length
        ex   de,hl
        sbc  hl,bc
        ex   de,hl           ;DE=new line length
        ld   (hl),e
        inc  hl
        ld   (hl),d
        ret


;      ------------------------------------------------------------
;      *****
; 615 POKE de-k2,CODE "y":
;     FOR r=d(scr,k1) TO d(scr,k1)+d(scr,k2)-k1
; 620   IF PEEK r>=217 THEN
;         POKE r,PEEK r-201: POKE r+k1,PEEK (r+k1)-96: LET r=r+k1
; 625   IF PEEK r>=172 THEN
;         POKE r,PEEK r-150: POKE r+k1,PEEK (r+k1)-96: POKE r+k2,PEEK (r+k2)-96: LET r=r+k2
; 630 NEXT r
;      *****
;      PRINT USR mcst,d(scr,k1),d(scr,k2),mcde;
DECODE: call FPTOBC          ;BC=DATA length
        push bc
        call FPTOBC          ;BC=DATA start
        ld   h,b
        ld   l,c             ;HL=DATA start
        pop  bc              ;BC=DATA length
        ld   de,4
        and  a
        sbc  hl,de
        ld   (hl),"y"        ;set decoded flag
        add  hl,de
NEXTATD:ld   a,(hl)
        cp   217
        jr   c,NOATTRD       ;not INK,PAPER,FLASH,BRIGHT,INVERSE,OVER
        sub  201
        ld   (hl),a
        jr   SPARAMD
NOATTRD:cp   172
        jr   c,NOATABD       ;not AT,TAB
        sub  150
        ld   (hl),a
        inc  hl
        dec  bc
        ld   a,(hl)
        sub  96
        ld   (hl),a
SPARAMD:inc  hl
        dec  bc
        ld   a,(hl)
        sub  96
        ld   (hl),a
NOATABD:inc  hl
        dec  bc
        ld   a,b
        or   c
        jr   nz,NEXTATD
        ret


;      ------------------------------------------------------------
;      *****
;      PRINT USR mcst,d(scr,k1),d(scr,k2),mcen;
ENCODE: call FPTOBC          ;BC=DATA length
        push bc
        call FPTOBC          ;BC=DATA start
        ld   h,b
        ld   l,c             ;HL=DATA start
        pop  bc              ;BC=DATA length
        ld   de,4
        and  a
        sbc  hl,de
        ld   (hl),"n"        ;set encoded flag
        add  hl,de
NEXTATE:ld   a,(hl)
        cp   22
        jr   nc,NOATTRE      ;not INK,PAPER,FLASH,BRIGHT,INVERSE,OVER
        add  a,201
        ld   (hl),a
        jr   SPARAME
NOATTRE:cp   24
        jr   nc,NOATABE      ;not AT,TAB
        add  a,150
        ld   (hl),a
        inc  hl
        dec  bc
        ld   a,(hl)
        add  a,96
        ld   (hl),a
SPARAME:inc  hl
        dec  bc
        ld   a,(hl)
        add  a,96
        ld   (hl),a
NOATABE:inc  hl
        dec  bc
        ld   a,b
        or   c
        jr   nz,NEXTATE
        ret



;      ------------------------------------------------------------
;      *****
;      PRINT USR mcst,d(s,k1),d(s,k2),"s$()",sync;

SYNCMS: call FIND_S          ;(CHARSP) = s$() array data address
        push hl
        ld   (hl)," "
        ld   d,h
        ld   e,l
        inc  de
        ld   bc,22*32-1
        ldir                 ;reset s$()
        call FPTOBC
        push bc              ;BC=screen DATA length
        call FPTOBC
        ld   h,b
        ld   l,c             ;HL=m$ screen DATA address
        pop  bc              ;BC=m$ screen DATA length
        pop  de              ;DE=s$() array data address
        ld   ix,COL
        ld   (ix+00),0

SYNC_A: push bc
        ld   a,(hl)
        cp   " "
        jr   c,SYNC_B
        ld   (de),a
        pop  bc
        dec  bc
        inc  hl
        inc  de
        inc  (ix+00)         ;COL
        res  5,(ix+00)       ;don't exceed 31
SYNC_X: ld   a,b
        or   c
        jr   nz,SYNC_A
        ret

SYNC_B: cp   24
        jp   nc,$1e9f        ;"B - Integer out of range"
        cp   16
        jp   c,$1e9f         ;"B - Integer out of range"
        cp   23
        jr   nz,SYNC_C
        inc  hl
        ld   c,(hl)          ;C =TAB col.N
        ld   a,c
        sub  (ix+00)         ;A =TAB col.N - COL
        jr   nc,NOWRAP
        add  a,32
NOWRAP: ld   (ix+00),c       ;COL = TAB col.N
        ld   b,0
        ld   c,a
        ex   de,hl
        add  hl,bc           ;adjust s$() address by col.diff
        ex   de,hl
        inc  hl
        inc  hl
        jr   SYNCC2

SYNC_C: cp   22
        jr   nz,SYNC_D
        inc  hl
        ld   a,(hl)          ;A =AT row.N
        push hl
        call STAKA
        ld   a,32
        call STAKA
        rst  $28
        defb $04,$38
        call FPTOBC          ;BC=row.N*32
        ld   hl,(CHARSP)
        add  hl,bc
        ex   de,hl           ;DE=row.N,col.0 address in s$()
        pop  hl
        inc  hl
        ld   b,0
        ld   c,(hl)          ;C =AT col.N
        ld   (ix+00),c       ;  =COL
        ex   de,hl
        add  hl,bc
        ex   de,hl           ;DE=row.N,col.N address in s$()
        inc  hl
SYNCC2: pop  bc
        dec  bc
        dec  bc
        dec  bc
        jr  SYNC_X

SYNC_D: pop  bc              ;INK,PAPER,FLASH,BRIGHT,INVERSE,OVER
        dec  bc
        dec  bc
        inc  hl
        inc  hl
        jr   SYNC_X

;      ------------------------------------------------------------
;      *****
LABELS: defw MCMOVE, ERASE, DECODE, ENCODE, SYNCMS
